Subject: Re: mmotm 2022-03-16-17-42 uploaded (uml sub-x86_64, sched/fair, RCU)

From: Andrew Morton <[email-masked]>
Date: Thu, 17 Mar 2022 16:51:00 -0700

On Wed, 16 Mar 2022 21:52:44 -0700 Randy Dunlap <[email-masked]> wrote:

> >> In file included from ./arch/x86/include/generated/asm/rwonce.h:1:0,
> >>                  from ../include/linux/compiler.h:248,
> >>                  from ../include/linux/kernel.h:20,
> >>                  from ../include/linux/cpumask.h:10,
> >>                  from ../include/linux/energy_model.h:4,
> >>                  from ../kernel/sched/fair.c:23:
> >> ../include/linux/psi.h: In function ‘cgroup_move_task’:
> >> ../include/linux/rcupdate.h:414:36: error: dereferencing pointer to incomplete type ‘struct css_set’
> >>  #define RCU_INITIALIZER(v) (typeof(*(v)) __force __rcu *)(v)
> >>                                     ^~~~
> > 
> > Works For Me.  I tried `make x86_64_defconfig' and `make i386_defconfig' too.
> > 
> > Can you please share that .config, or debug a bit?
> 
> $ make ARCH=um SUBARCH=x86_64 defconfig
> 

I still can't reproduce this :(

> This fixes the build error for me when CONFIG_PSI=n.

I have CONFIG_PSI=n

> ---
>  include/linux/psi.h |    3 +++
>  1 file changed, 3 insertions(+)
> 
> --- mmotm-2022-0316-1742.orig/include/linux/psi.h
> +++ mmotm-2022-0316-1742/include/linux/psi.h
> @@ -53,6 +53,9 @@ static inline int psi_cgroup_alloc(struc
>  static inline void psi_cgroup_free(struct cgroup *cgrp)
>  {
>  }
> +
> +#include <linux/cgroup-defs.h>
> +
>  static inline void cgroup_move_task(struct task_struct *p, struct css_set *to)
>  {
>  	rcu_assign_pointer(p->cgroups, to);

Nothing in -next touches psi.h so I am unable to determine which patch
needs fixing :(